<?php

use yii\db\Migration;

/**
 * Class m240821_182715_tablas_ObraHerramienta_ObraEmpleado
 */
class m240821_182715_tablas_ObraHerramienta_ObraEmpleado extends Migration
{
    /**
     * {@inheritdoc}
     */
    public function safeUp()
    {
        $this->createTable("ObraEmpleado", [
            "id" => $this->string(36),
            "idObra" => $this->string(36),
            "idEmpleado" => $this->string(36),
            "creado" => $this->timestamp()->append("with time zone"),
            "modificado" => $this->timestamp()->append("with time zone"),
            "eliminado" => $this->timestamp()->append("with time zone"),
        ]);

        $this->addPrimaryKey('ObraEmpleadoPK', 'ObraEmpleado', 'id');

        $this->addForeignKey('ObraEmpleadoObraFK', 'ObraEmpleado', 'idObra', 'Obra', 'id');
        $this->addForeignKey('ObraEmpleadoEmpleadoFK', 'ObraEmpleado', 'idEmpleado', 'Empleado', 'id');

        $this->createTable("ObraHerramienta", [
            "id" => $this->string(36),
            "idObra" => $this->string(36),
            "idHerramienta" => $this->string(36),
            "cantidad" => $this->integer(),
            "creado" => $this->timestamp()->append("with time zone"),
            "modificado" => $this->timestamp()->append("with time zone"),
            "eliminado" => $this->timestamp()->append("with time zone"),
        ]);

        $this->addPrimaryKey('ObraHerramientaPK', 'ObraHerramienta', 'id');

        $this->addForeignKey('ObraHerramientaObraFK', 'ObraHerramienta', 'idObra', 'Obra', 'id');
        $this->addForeignKey('ObraHerramientaHerramientaFK', 'ObraHerramienta', 'idHerramienta', 'Herramienta', 'id');
    
    }

    /**
     * {@inheritdoc}
     */
    public function safeDown()
    {
        $this->dropForeignKey('ObraHerramientaHerramientaFK', 'ObraHerramienta');
        $this->dropForeignKey('ObraHerramientaObraFK', 'ObraHerramienta');

        $this->dropTable('ObraHerramienta');

        $this->dropForeignKey('ObraEmpleadoEmpleadoFK', 'ObraEmpleado');
        $this->dropForeignKey('ObraEmpleadoObraFK', 'ObraEmpleado');

        $this->dropTable('ObraEmpleado');
    }
}
