<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "CompraProducto".
 *
 * @property string $id
 * @property string|null $idCompra
 * @property string|null $idUnidadMedida
 * @property string|null $idPartida
 * @property string|null $producto
 * @property string|null $cantidad
 * @property float|null $precio
 * @property string|null $descripcion
 * @property string|null $creado
 * @property string|null $modificado
 * @property string|null $eliminado
 *
 * @property Compra $idCompra0
 * @property Partida $idPartida0
 * @property UnidadMedida $idUnidadMedida0
 */
class CompraProducto extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'CompraProducto';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id'], 'required'],
            [['precio'], 'number'],
            [['descripcion'], 'string'],
            [['creado', 'modificado', 'eliminado'], 'safe'],
            [['id', 'idCompra', 'idUnidadMedida', 'idPartida'], 'string', 'max' => 36],
            [['producto', 'cantidad'], 'string', 'max' => 255],
            [['id'], 'unique'],
            [['idCompra'], 'exist', 'skipOnError' => true, 'targetClass' => Compra::class, 'targetAttribute' => ['idCompra' => 'id']],
            [['idPartida'], 'exist', 'skipOnError' => true, 'targetClass' => Partida::class, 'targetAttribute' => ['idPartida' => 'id']],
            [['idUnidadMedida'], 'exist', 'skipOnError' => true, 'targetClass' => UnidadMedida::class, 'targetAttribute' => ['idUnidadMedida' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'idCompra' => 'Id Compra',
            'idUnidadMedida' => 'Id Unidad Medida',
            'idPartida' => 'Id Partida',
            'producto' => 'Producto',
            'cantidad' => 'Cantidad',
            'precio' => 'Precio',
            'descripcion' => 'Descripcion',
            'creado' => 'Creado',
            'modificado' => 'Modificado',
            'eliminado' => 'Eliminado',
        ];
    }

    public function getCompra()
    {
        return $this->hasOne(Compra::class, ['id' => 'idCompra']);
    }

    public function getPartida()
    {
        return $this->hasOne(Partida::class, ['id' => 'idPartida']);
    }

    public function getUnidadMedida()
    {
        return $this->hasOne(UnidadMedida::class, ['id' => 'idUnidadMedida']);
    }
}
