<?php

namespace v1\controllers;

use common\data\Respuesta;
use common\rest\AuthController;
use yii\db\Expression;

class NominaController extends AuthController
{

  public $modelClass = "v1\models\Nomina";

  public function actionIndex()
  {
    $id = trim($this->req->get("id", ""));
    $idEmpleado = trim($this->req->get("empleado", ""));
    $idObra = trim($this->req->get("idObra", ""));
    $buscar = trim($this->req->get("q", ""));

    $query = $this->queryInicial;


    if ($id !== "") {
      $query->andWhere(["id" => $id]);
    }
   
    if ($idEmpleado !== "") {
        $query->andWhere(["idEmpleado" => $idEmpleado]);
    }

    if ($idObra !== "") {
        $query->andWhere(["idObra" => $idObra]);
    }

   

    return new Respuesta($query, $this->limite, $this->pagina, $this->ordenar);
  }

  public function actionGuardar()
  {
    $id = trim($this->req->getBodyParam("id", ""));
    $modelo = null;

    if ($id !== "") {
      $modelo = $this->modelClass::findOne($id);
    }
    if ($modelo === null) {
      $modelo = new $this->modelClass();
      $modelo->uuid();
      $modelo->creado = new Expression('now()');
    } else {
      $modelo->modificado = new Expression('now()');
    }
    $modelo->load($this->req->getBodyParams(), '');

  
    if (!$modelo->save()) {
      return (new Respuesta($modelo))
        ->mensaje("Hubo un problema al guardar la Nomina");
    }

    $modelo->refresh();
    return (new Respuesta($modelo))
      ->mensaje("Nomina guardada");
  }

  public function actionEliminar()
  {
    $id = trim($this->req->getBodyParam("id", ""));
    $modelo = null;

    if ($id !== "") {
      $modelo = $this->modelClass::findOne(["id" => $id]);
    }
    if ($modelo === null) {
      return (new Respuesta())
        ->esError()
        ->mensaje("Nomina no encontrado");
    }
    $modelo->eliminado = new Expression('now()');
    if (!$modelo->save()) {
      return (new Respuesta($modelo))
        ->mensaje("No se pudo eliminar la Nomina");
    }

    return (new Respuesta())
      ->mensaje("Nomina eliminada");
  }
}
