<?php

namespace v1\models;

use app\models\Merma as ModeloMerma;

class Merma extends ModeloMerma
{

    public function fields()
    {
        return [
            'id',
            'idObra',
            'idUnidadMedida',
            'idPartida',
            'idUsuario',
            'producto',
            'descripcion',
            'cantidad',
            'precio',
            'creado',
            'modificado',

        ];
    }
    public function extraFields() {
        return [
            'obra',
            'partida',
            'unidadMedida',
            'usuario',
        ];
    }

    public function getObra()
    {
        return $this->hasOne(Obra::class, ['id' => 'idObra']);
    }

    public function getPartida()
    {
        return $this->hasOne(Partida::class, ['id' => 'idPartida']);
    }

    public function getUnidadMedida()
    {
        return $this->hasOne(UnidadMedida::class, ['id' => 'idUnidadMedida']);
    }

    public function getUsuario()
    {
        return $this->hasOne(Usuario::class, ['id' => 'idUsuario']);
    }
}
